'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _web3_tools = require('../utils/web3_tools');

var _Pool = require('../contracts/Pool.json');

var _Pool2 = _interopRequireDefault(_Pool);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
Copyright: Ambrosus Inc.
Email: tech@ambrosus.io

This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/.

This Source Code Form is “Incompatible With Secondary Licenses”, as defined by the Mozilla Public License, v. 2.0.
*/

var PoolActions = function () {
  function PoolActions(web3) {
    (0, _classCallCheck3.default)(this, PoolActions);

    this.web3 = web3;
  }

  (0, _createClass3.default)(PoolActions, [{
    key: 'activate',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(address, value) {
        var contract;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return (0, _web3_tools.loadContract)(this.web3, _Pool2.default.abi, address);

              case 2:
                contract = _context.sent;
                _context.t0 = console;
                _context.next = 6;
                return contract.methods.activate().send({ gas: _web3_tools.DEFAULT_GAS, value: value, from: this.web3.eth.defaultAccount });

              case 6:
                _context.t1 = _context.sent;

                _context.t0.log.call(_context.t0, _context.t1);

              case 8:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function activate(_x, _x2) {
        return _ref.apply(this, arguments);
      }

      return activate;
    }()
  }, {
    key: 'stake',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(address, value) {
        var contract;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return (0, _web3_tools.loadContract)(this.web3, _Pool2.default.abi, address);

              case 2:
                contract = _context2.sent;
                _context2.t0 = console;
                _context2.next = 6;
                return contract.methods.stake().send({ gas: _web3_tools.DEFAULT_GAS, value: value, from: this.web3.eth.defaultAccount });

              case 6:
                _context2.t1 = _context2.sent;

                _context2.t0.log.call(_context2.t0, _context2.t1);

              case 8:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function stake(_x3, _x4) {
        return _ref2.apply(this, arguments);
      }

      return stake;
    }()
  }, {
    key: 'unstake',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(address, value) {
        var contract;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return (0, _web3_tools.loadContract)(this.web3, _Pool2.default.abi, address);

              case 2:
                contract = _context3.sent;
                _context3.t0 = console;
                _context3.next = 6;
                return contract.methods.unstake(value).send({ gas: _web3_tools.DEFAULT_GAS, from: this.web3.eth.defaultAccount });

              case 6:
                _context3.t1 = _context3.sent;

                _context3.t0.log.call(_context3.t0, _context3.t1);

              case 8:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function unstake(_x5, _x6) {
        return _ref3.apply(this, arguments);
      }

      return unstake;
    }()
  }]);
  return PoolActions;
}();

exports.default = PoolActions;