'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _toArray2 = require('babel-runtime/helpers/toArray');

var _toArray3 = _interopRequireDefault(_toArray2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _task_base = require('./base/task_base');

var _task_base2 = _interopRequireDefault(_task_base);

var _web3_tools = require('../utils/web3_tools');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
Copyright: Ambrosus Inc.
Email: tech@ambrosus.io

This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/.

This Source Code Form is “Incompatible With Secondary Licenses”, as defined by the Mozilla Public License, v. 2.0.
*/

var PoolingTask = function (_TaskBase) {
  (0, _inherits3.default)(PoolingTask, _TaskBase);

  function PoolingTask(multisigActions, poolActions) {
    (0, _classCallCheck3.default)(this, PoolingTask);

    var _this = (0, _possibleConstructorReturn3.default)(this, (PoolingTask.__proto__ || Object.getPrototypeOf(PoolingTask)).call(this));

    _this.multisigActions = multisigActions;
    _this.poolActions = poolActions;
    return _this;
  }

  (0, _createClass3.default)(PoolingTask, [{
    key: 'execute',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(_ref2) {
        var _ref3 = (0, _toArray3.default)(_ref2),
            command = _ref3[0],
            options = _ref3.slice(1);

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(command === 'add')) {
                  _context.next = 5;
                  break;
                }

                _context.next = 3;
                return this.addPool(options[0]);

              case 3:
                _context.next = 22;
                break;

              case 5:
                if (!(command === 'activate')) {
                  _context.next = 10;
                  break;
                }

                _context.next = 8;
                return this.activatePool(options[0], options[1]);

              case 8:
                _context.next = 22;
                break;

              case 10:
                if (!(command === 'stake')) {
                  _context.next = 15;
                  break;
                }

                _context.next = 13;
                return this.stake(options[0], options[1]);

              case 13:
                _context.next = 22;
                break;

              case 15:
                if (!(command === 'unstake')) {
                  _context.next = 20;
                  break;
                }

                _context.next = 18;
                return this.unstake(options[0], options[1]);

              case 18:
                _context.next = 22;
                break;

              case 20:
                console.error('Unknown sub-command, see yarn task pooling help');
                process.exit(1);

              case 22:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function execute(_x) {
        return _ref.apply(this, arguments);
      }

      return execute;
    }()
  }, {
    key: 'addPool',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(poolAddress) {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!_web3_tools.utils.isAddress(poolAddress)) {
                  _context2.next = 2;
                  break;
                }

                return _context2.abrupt('return', this.multisigActions.addPool(poolAddress));

              case 2:
                console.error('Wrong address, use: yarn task pooling add [pool address]');

              case 3:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function addPool(_x2) {
        return _ref4.apply(this, arguments);
      }

      return addPool;
    }()
  }, {
    key: 'activatePool',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(poolAddress, stake) {
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (!_web3_tools.utils.isAddress(poolAddress)) {
                  _context3.next = 2;
                  break;
                }

                return _context3.abrupt('return', this.poolActions.activate(poolAddress, this.poolActions.web3.utils.toWei(stake, 'ether')));

              case 2:
                console.error('Wrong address, use: yarn task pooling activate [pool address]');

              case 3:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function activatePool(_x3, _x4) {
        return _ref5.apply(this, arguments);
      }

      return activatePool;
    }()
  }, {
    key: 'stake',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(poolAddress, value) {
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                if (!_web3_tools.utils.isAddress(poolAddress)) {
                  _context4.next = 2;
                  break;
                }

                return _context4.abrupt('return', this.poolActions.stake(poolAddress, this.poolActions.web3.utils.toWei(value, 'ether')));

              case 2:
                console.error('Wrong address, use: yarn task pooling stake [pool address]');

              case 3:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function stake(_x5, _x6) {
        return _ref6.apply(this, arguments);
      }

      return stake;
    }()
  }, {
    key: 'unstake',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(poolAddress, value) {
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                if (!_web3_tools.utils.isAddress(poolAddress)) {
                  _context5.next = 2;
                  break;
                }

                return _context5.abrupt('return', this.poolActions.unstake(poolAddress, this.poolActions.web3.utils.toWei(value, 'ether')));

              case 2:
                console.error('Wrong address, use: yarn task pooling stake [pool address]');

              case 3:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function unstake(_x7, _x8) {
        return _ref7.apply(this, arguments);
      }

      return unstake;
    }()
  }, {
    key: 'help',
    value: function help() {
      return {
        description: 'add new pool to manager'
      };
    }
  }]);
  return PoolingTask;
}(_task_base2.default);

exports.default = PoolingTask;