'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _web3_tools = require('../utils/web3_tools');

var _contract_jsons = require('../contract_jsons');

var _contract_jsons2 = _interopRequireDefault(_contract_jsons);

var _contract_wrapper = require('./contract_wrapper');

var _contract_wrapper2 = _interopRequireDefault(_contract_wrapper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/** @abstract */
var ManagedContractWrapper = function (_ContractWrapper) {
  (0, _inherits3.default)(ManagedContractWrapper, _ContractWrapper);

  function ManagedContractWrapper(headWrapper, web3, defaultAddress) {
    (0, _classCallCheck3.default)(this, ManagedContractWrapper);

    var _this = (0, _possibleConstructorReturn3.default)(this, (ManagedContractWrapper.__proto__ || Object.getPrototypeOf(ManagedContractWrapper)).call(this, web3, defaultAddress));

    _this.headWrapper = headWrapper;
    _this.cachedContractObject = null;
    _this.cachedContractAddress = null;
    return _this;
  }

  (0, _createClass3.default)(ManagedContractWrapper, [{
    key: 'address',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt('return', this.headWrapper.contractAddressByName(this.getContractName));

              case 1:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function address() {
        return _ref.apply(this, arguments);
      }

      return address;
    }()
  }, {
    key: 'contract',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
        var contractAddress;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.headWrapper.contractAddressByName(this.getContractName);

              case 2:
                contractAddress = _context2.sent;

                if (!(contractAddress === undefined)) {
                  _context2.next = 5;
                  break;
                }

                throw new Error('Contract is not deployed');

              case 5:
                if (this.cachedContractAddress !== contractAddress) {
                  this.cachedContractObject = (0, _web3_tools.loadContract)(this.web3, _contract_jsons2.default[this.getContractName].abi, contractAddress);
                  this.cachedContractAddress = contractAddress;
                }
                return _context2.abrupt('return', this.cachedContractObject);

              case 7:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function contract() {
        return _ref2.apply(this, arguments);
      }

      return contract;
    }()
  }, {
    key: 'getContractName',
    get: function get() {
      throw new Error('Abstract method getContractName needs to be overridden');
    }
  }]);
  return ManagedContractWrapper;
}(_contract_wrapper2.default); /*
                               Copyright: Ambrosus Inc.
                               Email: tech@ambrosus.io
                               
                               This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/.
                               
                               This Source Code Form is “Incompatible With Secondary Licenses”, as defined by the Mozilla Public License, v. 2.0.
                               */

exports.default = ManagedContractWrapper;