'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _contract_wrapper = require('./contract_wrapper');

var _contract_wrapper2 = _interopRequireDefault(_contract_wrapper);

var _web3_tools = require('../utils/web3_tools');

var _contract_jsons = require('../contract_jsons');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PoolWrapper = function (_ContractWrapper) {
  (0, _inherits3.default)(PoolWrapper, _ContractWrapper);

  function PoolWrapper(contractAddress, web3, defaultAddress) {
    (0, _classCallCheck3.default)(this, PoolWrapper);

    var _this = (0, _possibleConstructorReturn3.default)(this, (PoolWrapper.__proto__ || Object.getPrototypeOf(PoolWrapper)).call(this, web3, defaultAddress));

    _this.address = contractAddress;
    _this.contract = (0, _web3_tools.loadContract)(web3, _contract_jsons.pool.abi, contractAddress);
    return _this;
  }

  (0, _createClass3.default)(PoolWrapper, [{
    key: 'getNodesCount',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt('return', this.contract.methods.getNodesCount().call());

              case 1:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getNodesCount() {
        return _ref.apply(this, arguments);
      }

      return getNodesCount;
    }()
  }, {
    key: 'getNode',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(idx) {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.abrupt('return', this.contract.methods.nodes(idx).call());

              case 1:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function getNode(_x) {
        return _ref2.apply(this, arguments);
      }

      return getNode;
    }()
  }, {
    key: 'getNodes',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(from, to) {
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                return _context3.abrupt('return', this.contract.methods.getNodes(from, to).call());

              case 1:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function getNodes(_x2, _x3) {
        return _ref3.apply(this, arguments);
      }

      return getNodes;
    }()
  }, {
    key: 'addNode',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(address) {
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                return _context4.abrupt('return', this.processTransaction(this.contract.methods.addNode(address)));

              case 1:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function addNode(_x4) {
        return _ref4.apply(this, arguments);
      }

      return addNode;
    }()
  }]);
  return PoolWrapper;
}(_contract_wrapper2.default); /*
                               Copyright: Ambrosus Inc.
                               Email: tech@ambrosus.io
                               
                               This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/.
                               
                               This Source Code Form is “Incompatible With Secondary Licenses”, as defined by the Mozilla Public License, v. 2.0.
                               */

exports.default = PoolWrapper;